Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 280705)
+++ channels/chan_sip.c	(working copy)
@@ -9875,12 +9875,22 @@
 		from = NULL;
 
 	if (from) {
+		int bracket = 0;
+
 		/* Strip any params or options from user */
 		if ((a = strchr(from, ';')))
 			*a = '\0';
 		/* Strip port from domain if present */
-		if ((a = strchr(from, ':')))
-			*a = '\0';
+		for (a = from; *a != '\0'; ++a) {
+			if (*a == ':' && bracket == 0) {
+				*a = '\0';
+				break;
+			} else if (*a == '[') {
+				++bracket;
+			} else if (*a == ']') {
+				--bracket;
+			}
+		}
 		if ((a = strchr(from, '@'))) {
 			*a = '\0';
 			ast_copy_string(domain, a + 1, len);
